﻿using System;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 데이터 출력하기 - PrintData(sourceArray)

        /// <summary>
        /// 데이터 출력하기
        /// </summary>
        /// <param name="sourceArray">소스 배열</param>
        private static void PrintData(byte[] sourceArray)
        {
            for(int i = 0; i < sourceArray.Length; i++)
            {
                Console.Write($"{sourceArray[i]:X2}");

                if(i < sourceArray.Length - 1)
                {
                    Console.Write(",");
                }
                else
                {
                    Console.WriteLine();
                }
            }
        }

        #endregion

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            byte[] userKeyArray =
            {
                0x88, 0xe3, 0x4f, 0x8f, 0x08, 0x17, 0x79, 0xf1,
                0xe9, 0xf3, 0x94, 0x37, 0x0a, 0xd4, 0x05, 0x89
            };

            HIGHTECB ecb = new HIGHTECB(userKeyArray);

            string plainText = "테스트 문자열";

            Console.WriteLine($"평문 텍스트        : {plainText}");

            byte[] plainByteArray = Encoding.UTF8.GetBytes(plainText);

            Console.Write("평문 바이트 배열   : ");

            PrintData(plainByteArray);

            byte[] encryptedByteArray = ecb.Encrypt(plainByteArray);

            Console.Write("암호화 바이트 배열 : ");

            PrintData(encryptedByteArray);

            byte[] decryptedByteArray = ecb.Decrypt(encryptedByteArray);

            Console.Write("복호화 바이트 배열 : ");

            PrintData(decryptedByteArray);

            string decryptedText = Encoding.UTF8.GetString(decryptedByteArray);

            Console.WriteLine($"복호화 텍스트      : {decryptedText}");
        }

        #endregion
    }
}